Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Parsers/CordeauParser.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Parsers/CordeauParser.cs	(revision 6851)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Parsers/CordeauParser.cs	(revision 6851)
@@ -0,0 +1,180 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Text.RegularExpressions;
+
+namespace HeuristicLab.Problems.VehicleRouting.Parsers {
+  class CordeauParser {
+    private string file;
+    private string problemName;
+    private int cities;
+    private int depots;
+    private int vehicles;
+    private List<double> capacity;
+    private List<double> xCoord;
+    private List<double> yCoord;
+    private List<double> demand;
+    private List<double> readyTime;
+    private List<double> dueTime;
+    private List<double> serviceTime;
+
+    public int Cities {
+      get {
+        return cities;
+      }
+    }
+
+    public int Depots {
+      get {
+        return depots;
+      }
+    }
+
+    public int Vehicles {
+      get {
+        return vehicles;
+      }
+    }
+
+    public double[] Capacity {
+      get {
+        return capacity.ToArray();
+      }
+    }
+
+    public double[,] Coordinates {
+      get {
+        double[] x = xCoord.ToArray();
+        double[] y = yCoord.ToArray();
+        double[,] coord = new double[x.Length, 2];
+        for (int i = 0; i < x.Length; i++) {
+          coord[i, 0] = x[i];
+          coord[i, 1] = y[i];
+        }
+        return coord;
+      }
+    }
+
+    public double[] Demands {
+      get {
+        return demand.ToArray();
+      }
+    }
+
+    public double[] Readytimes {
+      get {
+        return readyTime.ToArray();
+      }
+    }
+
+    public double[] Duetimes {
+      get {
+        return dueTime.ToArray();
+      }
+    }
+
+    public double[] Servicetimes {
+      get {
+        return serviceTime.ToArray();
+      }
+    }
+
+    public String ProblemName {
+      get {
+        return problemName;
+      }
+    }
+
+    public CordeauParser(string file) {
+      this.file = file;
+      capacity = new List<double>();
+      xCoord = new List<double>();
+      yCoord = new List<double>();
+      demand = new List<double>();
+      readyTime = new List<double>();
+      dueTime = new List<double>();
+      serviceTime = new List<double>();
+    }
+
+    public void Parse() {
+      string line;
+      Regex reg = new Regex(@"-?\d+(\.\d+)?");
+      MatchCollection m;
+
+      StreamReader reader = new StreamReader(file);
+
+      problemName = Path.GetFileNameWithoutExtension(file);
+      line = reader.ReadLine();
+
+      m = reg.Matches(line);
+      if (m.Count != 4)
+        throw new InvalidDataException("File has wrong format!");
+
+      vehicles = int.Parse(m[3].Value);
+      line = reader.ReadLine();
+
+      for (int i = 0; i < vehicles; i++) {
+        m = reg.Matches(line);
+        if (m.Count != 2) { continue; }
+
+        capacity.Add(double.Parse(m[1].Value, System.Globalization.CultureInfo.InvariantCulture));
+
+        line = reader.ReadLine();
+      }
+
+      List<double> depotXcoord = new List<double>();
+      List<double> depotYcoord = new List<double>();
+      while ((line != null)) {
+        m = reg.Matches(line);
+
+        if (m.Count == 11) {
+          xCoord.Add(double.Parse(m[1].Value, System.Globalization.CultureInfo.InvariantCulture));
+          yCoord.Add(double.Parse(m[2].Value, System.Globalization.CultureInfo.InvariantCulture));
+          demand.Add((double)int.Parse(m[4].Value, System.Globalization.CultureInfo.InvariantCulture));
+        } else if (m.Count == 7) {
+          depotXcoord.Add(double.Parse(m[1].Value, System.Globalization.CultureInfo.InvariantCulture));
+          depotYcoord.Add(double.Parse(m[2].Value, System.Globalization.CultureInfo.InvariantCulture));
+        }
+               
+        line = reader.ReadLine();
+      }
+
+      xCoord.InsertRange(0, depotXcoord);
+      yCoord.InsertRange(0, depotYcoord);
+
+      cities = demand.Count;
+      depots = depotXcoord.Count;
+
+      vehicles *= depots;
+      List<double> originalCapacities = new List<double>(capacity);
+      for (int i = 1; i < depots; i++) {
+        capacity.InsertRange(0, originalCapacities);
+      }
+    }
+
+    internal string OnReset() {
+      throw new NotImplementedException();
+    }
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPEvaluator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPEvaluator.cs	(revision 6851)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPEvaluator.cs	(revision 6851)
@@ -0,0 +1,155 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+using HeuristicLab.Problems.VehicleRouting.Encodings;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  [Item("MDCVRPEvaluator", "Represents a multi depot CVRP evaluator.")]
+  [StorableClass]
+  public class MDCVRPEvaluator: VRPEvaluator {
+    public ILookupParameter<DoubleValue> OverloadParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Overload"]; }
+    }
+
+    protected override VRPEvaluation CreateTourEvaluation() {
+      return new CVRPEvaluation();
+    }
+
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncoding solution) {
+      TourInsertionInfo tourInfo = new TourInsertionInfo();
+      eval.InsertionInfo.AddTourInsertionInfo(tourInfo);
+
+      IHeterogenousCapacitatedProblemInstance cvrpInstance = instance as IHeterogenousCapacitatedProblemInstance;
+
+      double delivered = 0.0;
+      double overweight = 0.0;
+      double distance = 0.0;
+
+      int tourIndex = solution.GetTourIndex(tour);
+      int vehicle = solution.GetVehicleAssignment(tourIndex);
+
+      double capacity = cvrpInstance.Capacity[vehicle];
+      for (int i = 0; i < tour.Stops.Count; i++) {
+        delivered += instance.GetDemand(tour.Stops[i]);
+      }
+
+      double spareCapacity = capacity - delivered;
+
+      //simulate a tour, start and end at depot
+      for (int i = 0; i <= tour.Stops.Count; i++) {
+        int start = 0;
+        if (i > 0)
+          start = tour.Stops[i - 1];
+        int end = 0;
+        if (i < tour.Stops.Count)
+          end = tour.Stops[i];
+
+        //drive there
+        double currentDistace = instance.GetDistance(start, end, solution);
+        distance += currentDistace;
+
+        CVRPInsertionInfo stopInfo = new CVRPInsertionInfo(start, end, spareCapacity);
+        tourInfo.AddStopInsertionInfo(stopInfo);
+      }
+
+      eval.Quality += instance.FleetUsageFactor.Value;
+      eval.Quality += instance.DistanceFactor.Value * distance;
+
+      eval.Distance += distance;
+      eval.VehicleUtilization += 1;
+
+      if (delivered > capacity) {
+        overweight = delivered - capacity;
+      }
+
+      (eval as CVRPEvaluation).Overload += overweight;
+      double penalty = overweight * cvrpInstance.OverloadPenalty.Value;
+      eval.Penalty += penalty;
+      eval.Quality += penalty;
+      tourInfo.Penalty = penalty;
+    }
+
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer, 
+      out bool feasible) {
+      CVRPInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index) as CVRPInsertionInfo;
+      
+      double costs = 0;
+      feasible = tourInsertionInfo.Penalty < double.Epsilon;
+
+      IHeterogenousCapacitatedProblemInstance cvrp = instance as IHeterogenousCapacitatedProblemInstance;
+      double overloadPenalty = cvrp.OverloadPenalty.Value;
+
+      costs += instance.GetInsertionDistance(insertionInfo.Start, customer, insertionInfo.End, solution);
+
+      double demand = instance.GetDemand(customer);
+      if (demand > insertionInfo.SpareCapacity) {
+        feasible = false;
+
+        if(insertionInfo.SpareCapacity >= 0)
+          costs += (demand - insertionInfo.SpareCapacity) * overloadPenalty;
+        else
+          costs += demand * overloadPenalty;
+      }
+      
+      return costs;
+    }
+
+    protected override void InitResultParameters() {
+      base.InitResultParameters();
+
+      OverloadParameter.ActualValue = new DoubleValue(0);
+    }
+
+    protected override void SetResultParameters(VRPEvaluation tourEvaluation) {
+      base.SetResultParameters(tourEvaluation);
+
+      OverloadParameter.ActualValue.Value = (tourEvaluation as CVRPEvaluation).Overload;
+    }
+    
+    [StorableConstructor]
+    protected MDCVRPEvaluator(bool deserializing) : base(deserializing) { }
+
+    public MDCVRPEvaluator() {
+      Parameters.Add(new LookupParameter<DoubleValue>("Overload", "The overload."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MDCVRPEvaluator(this, cloner);
+    }
+
+    protected MDCVRPEvaluator(MDCVRPEvaluator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPProblemInstance.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPProblemInstance.cs	(revision 6851)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPProblemInstance.cs	(revision 6851)
@@ -0,0 +1,132 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  [Item("MDCVRPProblemInstance", "Represents a multi depot CVRP instance.")]
+  [StorableClass]
+  public class MDCVRPProblemInstance: MultiDepotVRPProblemInstance, IHeterogenousCapacitatedProblemInstance {
+    protected IValueParameter<DoubleArray> CapacityParameter {
+      get { return (IValueParameter<DoubleArray>)Parameters["Capacity"]; }
+    }
+    protected IValueParameter<DoubleValue> OverloadPenaltyParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters["EvalOverloadPenalty"]; }
+    }
+
+    public DoubleArray Capacity {
+      get { return CapacityParameter.Value; }
+      set { CapacityParameter.Value = value; }
+    }
+
+    [Storable]
+    private DoubleValue currentOverloadPenalty;
+
+    public DoubleValue OverloadPenalty {
+      get {
+        if (currentOverloadPenalty != null)
+          return currentOverloadPenalty;
+        else
+          return OverloadPenaltyParameter.Value; }
+      set { currentOverloadPenalty = value; }
+    }
+
+    protected override IEnumerable<IOperator> GetOperators() {
+        return base.GetOperators()
+          .Where(o => o is IHeterogenousCapacitatedOperator).Cast<IOperator>();
+    }
+
+    protected override IEnumerable<IOperator> GetAnalyzers() {
+      return ApplicationManager.Manager.GetInstances<ICapacitatedOperator>()
+        .Where(o => o is IAnalyzer)
+        .Cast<IOperator>().Union(base.GetAnalyzers());
+    }
+
+    protected override IVRPEvaluator Evaluator {
+      get {
+        return new MDCVRPEvaluator();
+      }
+    }
+    
+    [StorableConstructor]
+    protected MDCVRPProblemInstance(bool deserializing) : base(deserializing) { }
+
+    public MDCVRPProblemInstance() {
+      Parameters.Add(new ValueParameter<DoubleArray>("Capacity", "The capacity of each vehicle.", new DoubleArray()));
+      Parameters.Add(new ValueParameter<DoubleValue>("EvalOverloadPenalty", "The overload penalty considered in the evaluation.", new DoubleValue(100)));
+
+      AttachEventHandlers();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MDCVRPProblemInstance(this, cloner);
+    }
+
+    protected MDCVRPProblemInstance(MDCVRPProblemInstance original, Cloner cloner)
+      : base(original, cloner) {
+        currentOverloadPenalty = cloner.Clone(original.currentOverloadPenalty) as DoubleValue;
+
+        AttachEventHandlers();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserializationHook() {
+      AttachEventHandlers();
+    }
+
+    private void AttachEventHandlers() {
+      CapacityParameter.ValueChanged += new EventHandler(CapacityParameter_ValueChanged);
+      OverloadPenaltyParameter.ValueChanged += new EventHandler(OverloadPenaltyParameter_ValueChanged);
+      OverloadPenaltyParameter.Value.ValueChanged += new EventHandler(OverloadPenalty_ValueChanged);
+    }
+
+    public override void InitializeState() {
+      base.InitializeState();
+
+      currentOverloadPenalty = null;
+    }
+
+    #region Event handlers
+    void CapacityParameter_ValueChanged(object sender, EventArgs e) {
+      BestKnownSolution = null;
+    }
+    void OverloadPenaltyParameter_ValueChanged(object sender, EventArgs e) {
+      OverloadPenaltyParameter.Value.ValueChanged += new EventHandler(OverloadPenalty_ValueChanged);
+      EvalBestKnownSolution();
+    }
+    void OverloadPenalty_ValueChanged(object sender, EventArgs e) {
+      EvalBestKnownSolution();
+    }
+    #endregion
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MultiDepotVRPEvaluator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MultiDepotVRPEvaluator.cs	(revision 6851)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MultiDepotVRPEvaluator.cs	(revision 6851)
@@ -0,0 +1,103 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+using HeuristicLab.Problems.VehicleRouting.Encodings;
+using HeuristicLab.Common;
+
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  [Item("SingleDepotVRPEvaluator", "Represents a single depot VRP evaluator.")]
+  [StorableClass]
+  public class MultiDepotVRPEvaluator: VRPEvaluator {
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncoding solution) {
+      TourInsertionInfo tourInfo = new TourInsertionInfo();
+      eval.InsertionInfo.AddTourInsertionInfo(tourInfo);
+      
+      double distance = 0.0;
+      double quality = 0.0;
+
+      //simulate a tour, start and end at depot
+      for (int i = 0; i <= tour.Stops.Count; i++) {
+        int start = 0;
+        if (i > 0)
+          start = tour.Stops[i - 1];
+        int end = 0;
+        if (i < tour.Stops.Count)
+          end = tour.Stops[i];
+
+        //drive there
+        double currentDistace = instance.GetDistance(start, end, solution);
+        distance += currentDistace;
+
+        StopInsertionInfo stopInfo = new StopInsertionInfo(start, end);
+        tourInfo.AddStopInsertionInfo(stopInfo);
+      }
+
+      //Fleet usage
+      quality += instance.FleetUsageFactor.Value;
+      //Distance
+      quality += instance.DistanceFactor.Value * distance;
+
+      eval.Distance += distance;
+      eval.VehicleUtilization += 1;
+
+      eval.Quality += quality;
+    }
+
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
+      out bool feasible) {
+      StopInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index);
+      
+      double costs = 0;
+      feasible = true;
+
+      costs += instance.GetInsertionDistance(insertionInfo.Start, customer, insertionInfo.End, solution);
+
+      return costs;
+    }
+    
+    [StorableConstructor]
+    protected MultiDepotVRPEvaluator(bool deserializing) : base(deserializing) { }
+
+    public MultiDepotVRPEvaluator() {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MultiDepotVRPEvaluator(this, cloner);
+    }
+
+    protected MultiDepotVRPEvaluator(MultiDepotVRPEvaluator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MultiDepotVRPProblemInstance.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MultiDepotVRPProblemInstance.cs	(revision 6851)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MultiDepotVRPProblemInstance.cs	(revision 6851)
@@ -0,0 +1,189 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  [Item("MultiDepotVRPProblemInstance", "Represents a multi depot VRP instance.")]
+  [StorableClass]
+  public class MultiDepotVRPProblemInstance: VRPProblemInstance, IMultiDepotProblemInstance {
+    protected IValueParameter<IntValue> DepotsParameter {
+      get { return (IValueParameter<IntValue>)Parameters["Depots"]; }
+    }
+
+    protected IValueParameter<IntArray> VehicleDepotAssignmentParameter {
+      get { return (IValueParameter<IntArray>)Parameters["VehicleDepotAssignment"]; }
+    }
+
+    public IntValue Depots {
+      get {
+        return DepotsParameter.Value;
+      }
+    }
+
+    public IntArray VehicleDepotAssignment {
+      get {
+        return VehicleDepotAssignmentParameter.Value;
+      }
+      set {
+        VehicleDepotAssignmentParameter.Value = value;
+      }
+    }
+    
+    protected override IEnumerable<IOperator> GetOperators() {
+      return ApplicationManager.Manager.GetInstances<IMultiDepotOperator>().Cast<IOperator>();
+    }
+
+    protected override IEnumerable<IOperator> GetAnalyzers() {
+      return ApplicationManager.Manager.GetInstances<IMultiDepotOperator>()
+        .Where(o => o is IAnalyzer)
+        .Cast<IOperator>();
+    }
+
+    public override IntValue Cities {
+      get {
+        return new IntValue(Demand.Length);
+      }
+    }
+
+    protected override IVRPEvaluator Evaluator {
+      get {
+        return new MultiDepotVRPEvaluator();
+      }
+    }
+
+    protected override IVRPCreator Creator {
+      get {
+        return new HeuristicLab.Problems.VehicleRouting.Encodings.Alba.RandomCreator();
+      }
+    }
+
+    public override double GetDemand(int city) {
+      return base.GetDemand(city - 1);
+    }
+
+    public override double[] GetCoordinates(int city) {
+      double[] coordinates;
+      
+      if (city == 0) {
+        //calculate centroid
+        coordinates = new double[Coordinates.Columns];
+
+        for (int i = 0; i < Depots.Value; i++) {
+          for (int j = 0; j < coordinates.Length; j++) {
+            coordinates[j] += Coordinates[i, j];
+          }
+        }
+
+        for (int j = 0; j < coordinates.Length; j++) {
+          coordinates[j] /= (double)Depots.Value;
+        }
+      } else {
+        city += Depots.Value - 1;
+        coordinates = base.GetCoordinates(city);
+      }
+
+      return coordinates;
+    }
+
+    public int GetDepot(int customer, IVRPEncoding solution) {
+      int depot = -1;
+      
+      Tour tour =
+          solution.GetTours().FirstOrDefault(t => t.Stops.Contains(customer));
+
+      if (tour != null) {
+        int tourIndex = solution.GetTourIndex(tour);
+        int vehicle = solution.GetVehicleAssignment(tourIndex);
+        depot = VehicleDepotAssignment[vehicle];
+      }
+
+      return depot;
+    }
+
+    public override double GetDistance(int start, int end, IVRPEncoding solution) {
+      if (start == 0 && end == 0)
+        return 0;
+      
+      if (start == 0) {
+        start = GetDepot(end, solution);
+        end += Depots.Value - 1;
+      } else if (end == 0) {
+        end = GetDepot(start, solution);
+        start += Depots.Value - 1;
+      } else {
+        start += Depots.Value - 1;
+        end += Depots.Value - 1;
+      }
+      
+      return base.GetDistance(start, end, solution);
+    }
+
+    public override double GetInsertionDistance(int start, int customer, int end, IVRPEncoding solution) {
+      if (start == 0) {
+        start = GetDepot(end, solution);
+        end += Depots.Value - 1;
+      } else if (end == 0) {
+        end = GetDepot(start, solution);
+        start += Depots.Value - 1;
+      } else {
+        start += Depots.Value - 1;
+        end += Depots.Value - 1;
+      }
+      customer += Depots.Value - 1;
+      
+      double distance = base.GetDistance(start, end, solution);
+      double newDistance =
+        base.GetDistance(start, customer, solution) +
+        base.GetDistance(customer, end, solution);
+
+      return newDistance - distance;
+    }
+    
+    [StorableConstructor]
+    protected MultiDepotVRPProblemInstance(bool deserializing) : base(deserializing) { }
+
+    public MultiDepotVRPProblemInstance() {
+      Parameters.Add(new ValueParameter<IntValue>("Depots", "The number of depots", new IntValue(0)));
+      Parameters.Add(new ValueParameter<IntArray>("VehicleDepotAssignment", "The assignment of vehicles to depots", new IntArray()));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MultiDepotVRPProblemInstance(this, cloner);
+    }
+
+    protected MultiDepotVRPProblemInstance(MultiDepotVRPProblemInstance original, Cloner cloner)
+      : base(original, cloner) {
+    }
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPEvaluator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPEvaluator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPEvaluator.cs	(revision 6851)
@@ -38,5 +38,5 @@
   [Item("CVRPEvaluator", "Represents a single depot CVRP evaluator.")]
   [StorableClass]
-  public class CVRPEvaluator: SingleDepotVRPEvaluator {
+  public class CVRPEvaluator: VRPEvaluator {
     public ILookupParameter<DoubleValue> OverloadParameter {
       get { return (ILookupParameter<DoubleValue>)Parameters["Overload"]; }
@@ -79,5 +79,5 @@
 
         //drive there
-        double currentDistace = instance.GetDistance(start, end);
+        double currentDistace = instance.GetDistance(start, end, solution);
         distance += currentDistace;
 
@@ -103,5 +103,5 @@
     }
 
-    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, TourInsertionInfo tourInsertionInfo, int index, int customer, 
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer, 
       out bool feasible) {
       CVRPInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index) as CVRPInsertionInfo;
@@ -113,8 +113,8 @@
       double overloadPenalty = cvrp.OverloadPenalty.Value;
 
-      double distance = instance.GetDistance(insertionInfo.Start, insertionInfo.End);
+      double distance = instance.GetDistance(insertionInfo.Start, insertionInfo.End, solution);
       double newDistance =
-        instance.GetDistance(insertionInfo.Start, customer) +
-        instance.GetDistance(customer, insertionInfo.End);
+        instance.GetDistance(insertionInfo.Start, customer, solution) +
+        instance.GetDistance(customer, insertionInfo.End, solution);
       costs += instance.DistanceFactor.Value * (newDistance - distance);
 
